<template>
    <div id="page-wrapper">
        <div id="auth-container">
            <div class="text-right mb-2 server-status">
                <small>
                    <span v-if="componentC">👍 Component C is ONLINE!</span>
                    <span v-else>👎 Component C is OFFLINE!</span>
                </small>
            </div>
            <div id="form-area">
                <form class="form-signin" @submit.prevent="handleSubmit()" autocomplete="off">
                    <img class="mb-4" src="https://vuejs.org/images/logo.png" alt="" width="72"
                         height="72">
                    <h2 class="h3 mb-3 font-weight-normal">COMPONENTE A</h2>
                    <div class="mt-3 text-left">
                        <label for="inputUsername">Username</label>
                        <input type="text" id="inputUsername" class="form-control" placeholder="Username"
                               required=""
                               autofocus="" v-model="loginForm.username"></div>
                    <div class="mt-3 text-left">
                        <label for="inputPassword">Password</label>
                        <input type="password" id="inputPassword" class="form-control" placeholder="Password"
                               required=""
                               v-model="loginForm.password" autocomplete="off">
                    </div>
                    <div class="mt-3">
                        <button class="btn btn-lg btn-login btn-block" type="submit">SIGN IN</button>
                    </div>
                    <div class="mt-2">
                        Created by <a href="http://www.enricoschintu.it" target="_blank">Enrico Schintu</a>
                    </div>
                </form>
            </div>
            <div v-if="result" class="mt-4">
                <span>{{result}}</span>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import {Component, Vue} from "vue-property-decorator";
    import LoginForm from "@/models/login-form.model";
    import {AxiosResponse} from "axios";
    import {X_AUTH_TOKEN} from "@/consts/app.constant";
    import {AuthUtils} from "@/utils/auth-utils";

    const INIT_STATE: LoginForm = {username: "", password: ""};

    @Component({
        components: {}
    })
    export default class Login extends Vue {
        public loginForm: LoginForm = {...INIT_STATE};

        public result: string = "";

        public componentC: boolean = false;

        public created() {
            this.reset();
            this.checkComponentC();
        }

        public reset(): void {
            AuthUtils.removeAuthentication();
            this.loginForm = {...INIT_STATE};
            this.result = "";
        }

        public handleSubmit(): void {
            const {username, password} = this.loginForm;
            if (!!username && !!password) {
                const credentials = `username=${encodeURIComponent(
                    username
                )}&password=${encodeURIComponent(password)}`;
                this.$http
                    .post("http://localhost:8080/authentication", credentials)
                    .then((response: AxiosResponse) => {
                        AuthUtils.setAuthentication(response.data[X_AUTH_TOKEN], username);
                        this.result = "😁 Login Success";
                        this.$router.push({name: "home", params: {username}});
                    })
                    .catch(error => {
                        AuthUtils.removeAuthentication();
                        this.result = `😖 ${error.response.data.message}`;
                    });
            } else {
                this.result = "☝️ A username and password must be present";
            }
        }

        private checkComponentC(): void {
            this.$http
                .get("http://localhost:8080/test/status")
                .then((response: AxiosResponse) => this.componentC = true)
                .catch(e => this.componentC = false);
        }
    }
</script>

<style>
    .form-signin {
        width: 100%;
    }

    #page-wrapper {
        height: 100vh;
        overflow: hidden;
        background-color: #db4c46;
    }

    #auth-container {
        max-width: 30em;
        margin: 12% auto;
    }

    #form-area {
        background-color: snow;
        border-radius: 1em;
        border: 1px solid #db4c46;
        color: #ff1c16;
        padding: 3em 3em 3em 3em;
    }

    .btn-login {
        color: #fff;
        background-color: #d9534f;
        border: 2px solid #d43f3a;
        border-radius: 0 !important;
        font-variant: all-small-caps;
    }

    .btn-login:hover {
        background-color: snow;
        color: #ff1c16;
        border: 2px solid #ff1c16;
    }

    .server-status {
        color: white;
    }
</style>
